VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmCurveLen 
   Caption         =   ""
   ClientHeight    =   2625
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2925
   OleObjectBlob   =   "frmCurveLen.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmCurveLen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const units = "millimeters|centimeters|meters|kilometers|inches|foots|yards|miles|pixels|"
Rem                 0           1         2         3       4     5     6     7      8
Const units_scale_from_mm = _
              "     1     |     10    | 1000 | 1e6      |  25.4|304.8|914.4|1609344|0.08466667|"
Private dblUnitScale(63) As Double
Private dblScale As Double
Private dblCorelScale(16) As Double
Private IsNotCurveCounter, IsCurveCounter, _
        ClosedCurveCounter, CurveHaveSubPath As Long
Private dblCurvesLenght As Double

Private Sub btnMeasure_Click()
    dblCurvesLenght = 0
    Call SelectionLength(ActiveDocument.SelectionRange)
    
    Call CreateReport
End Sub

Private Sub cbMeasurementUnits_Change()
    cbMeasurementUnits.SetFocus
    Call CreateReport

End Sub



Private Sub UserForm_Initialize()
    Dim n, lngDelimitPos As Long
    Dim szUnits, szUnitName As String
    ActiveDocument.Unit = cdrTenthMicron
    
    dblCorelScale(cdrTenthMicron) = 1 / 10000#
    dblCorelScale(cdrInch) = 25.4
    dblCorelScale(cdrFoot) = 304.8
    dblCorelScale(cdrMillimeter) = 1
    dblCorelScale(cdrCentimeter) = 10
    dblCorelScale(cdrPixel) = 25.4 / ActiveDocument.Resolution
    dblCorelScale(cdrMile) = 1609344#
    dblCorelScale(cdrMeter) = 1000#
    dblCorelScale(cdrKilometer) = 1000000#
    dblCorelScale(cdrDidots) = 0.37592
    dblCorelScale(cdrAgate) = 1 '!!!
    dblCorelScale(cdrYard) = 914.4
    dblCorelScale(cdrPica) = 1 / 4.2354
    dblCorelScale(cdrCicero) = 1 / 4.5118
    dblCorelScale(cdrPoint) = 25.4 / 72
    dblCorelScale(cdrUnitQ) = 4
    dblCorelScale(cdrUnitH) = 4
    
    szUnits = units & " "
    
    lngDelimitPos = InStr(1, szUnits, "|")
    Do
       cbMeasurementUnits.AddItem Trim$(Left$(szUnits, lngDelimitPos - 1))
       szUnits = Mid$(szUnits, lngDelimitPos + 1)
       lngDelimitPos = InStr(1, szUnits, "|")
    Loop While (lngDelimitPos > 0)
    
    szUnits = units_scale_from_mm & " "
    n = 0
    lngDelimitPos = InStr(1, szUnits, "|")
    Do
       dblUnitScale(n) = Val((Left$(szUnits, lngDelimitPos - 1)))
       n = n + 1
       szUnits = Mid$(szUnits, lngDelimitPos + 1)
       lngDelimitPos = InStr(1, szUnits, "|")
    Loop While (lngDelimitPos > 0)
    
    cbMeasurementUnits.ListIndex = 1

End Sub
Private Function ShapeLength(ByVal s As Shape) As Double
    Dim dblL As Double
    dblL = 0
    Select Case s.Type
            Case cdrCurveShape
                        IsCurveCounter = IsCurveCounter + 1
                        ShapeLength = s.Curve.Length
                        If s.Curve.Subpaths.Count > 1 Then CurveHaveSubPath = CurveHaveSubPath + 1
                        For Each spX In s.Curve.Subpaths
                            If spX.Closed Then ClosedCurveCounter = ClosedCurveCounter + 1
                        Next spX
            Case cdrRectangleShape, cdrEllipseShape, cdrPolygonShape
                        s.ConvertToCurves
                        ShapeLength = ShapeLength(s)
                        ActiveDocument.Undo
            Case cdrGroupShape
                        For Each shX In s.Shapes
                            dblL = dblL + ShapeLength(shX)
                        Next shX
                        ShapeLength = dblL
            Case Else
               ShapeLength = 0
               IsNotCurveCounter = IsNotCurveCounter + 1
      
        End Select
End Function
Private Sub SelectionLength(SelectedObj As ShapeRange)

Dim s As Shape
Dim dblLength As Double

dblCurvesLenght = 0
IsNotCurveCounter = 0: IsCurveCounter = 0:
ClosedCurveCounter = 0: CurveHaveSubPath = 0
If Not (SelectedObj Is Nothing) Then
    Set CurrentSelect = SelectedObj
    For Each s In SelectedObj
        dblCurvesLenght = dblCurvesLenght + ShapeLength(s)
    Next s
    For Each s In SelectedObj
        s.Selected = True
    Next s
End If
End Sub
Private Sub CreateReport()
Dim s, fmtString As String
Dim l As Double
    s = ""
    l = dblCurvesLenght * dblCorelScale(ActiveDocument.Unit) / dblUnitScale(cbMeasurementUnits.ListIndex)
    If (l > 0.009) Or (l < 0.000000001) Then
        fmtString = "0.000"
    Else
        fmtString = "#.###E+00"
    End If
    txtLen.Caption = Format(l, fmtString)
    If IsNotCurveCounter > 0 Then
        s = s & "     " & Str$(IsNotCurveCounter) & " "
        If (IsNotCurveCounter Mod 100) >= 9 And (IsNotCurveCounter Mod 100) <= 19 Then
            s = s & ""
        Else
            Select Case IsNotCurveCounter Mod 10
                Case 0, 2 To 9
                    s = s & ""
                Case 1
                    s = s & "a"
            End Select
        End If
    End If
    txtSummary.Caption = s
End Sub
